#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>
#include <math.h>

struct timeval t;
double now,later;

void handler(int sig)
{
    if (gettimeofday(&t,NULL)) {
	perror("gettimeofday");
	exit(1);
    }
    // Get again current time to see how much time has elapsed
    later=t.tv_sec+t.tv_usec/1E9;
    printf("Awakened (after %.9f secs.)\n",later-now);
}

int main(int argc, char *argv[])
{
    int s;

    if (argc!=2 || (s=atoi(argv[1]))<0) {
	fprintf(stderr,"Usage:\n\t%s <secs>\n",argv[0]);
	exit(1);
    }

    // Register the signal handler for SIGALRM
    signal(SIGALRM,handler);
    s=atoi(argv[1]);
    
    // Get current time
    if (gettimeofday(&t,NULL)) {
	perror("gettimeofday");
	exit(1);
    }
    // Compute time in secs
    now=t.tv_sec+t.tv_usec/1E9;

    // Set a timer that will expire in <s> seconds, generating a SIGALRM
    if (alarm(s)<0) {
	perror("alarm");
	exit(1);
    }

    // Suspend till a signal is caught
    pause();

    exit(0);
}
